----------------------------------------------------------------------
-- Fichero: MemProgPlantilla.vhd
-- Descripcin: Plantilla para la memoria de programa para el MIPS
-- Fecha ltima modificacin: 2017-03-27

-- Autores: Alberto Snchez (2012-2017), ngel de Castro (2010-2015) 
-- Asignatura: EC 1 grado
-- Grupo de Prcticas:
-- Grupo de Teora:
-- Prctica: 5
-- Ejercicio: 3
----------------------------------------------------------------------


library IEEE;
use IEEE.std_logic_1164.ALL;
use IEEE.std_LOGIC_arith.ALL;
use IEEE.std_logic_unsigned.ALL;

entity MemProgPlantilla is
	port (
		MemProgAddr : in std_logic_vector(31 downto 0); -- Direccin para la memoria de programa
		MemProgData : out std_logic_vector(31 downto 0) -- Cdigo de operacin
	);
end MemProgPlantilla;

architecture Simple of MemProgPlantilla is

begin

	LecturaMemProg: process(MemProgAddr)
	begin
		-- La memoria devuelve un valor para cada direccin.
		-- Estos valores son los cdigos de programa de cada instruccin,
		-- estando situado cada uno en su direccin.
		case MemProgAddr is
		-------------------------------------------------------------
		-- Slo introducir cambios desde aqu	

			-- Por cada instruccin en .text, agregar una lnea del tipo:
			-- when DIRECCION => MemProgData <= INSTRUCCION;
			-- Por ejemplo, si la posicin 0x00000000 debe guardarse la instruccin con cdigo mquina 0x20010004, poner:
			--when X"00000000" => MemProgData <= X"20010004";
		-- Hasta aqu	
		---------------------------------------------------------------------	
			
			when others => MemProgData <= X"00000000"; -- Resto de memoria vaca
		end case;
	end process LecturaMemProg;

end Simple;

